/* eslint-disable @typescript-eslint/no-explicit-any */
const isFn = (obj) => typeof obj === 'function';
const isAsyncFn = (fn) => {
    try {
        return fn.prototype.constructor.name.endsWith('Async');
    }
    catch (e) {
        return false;
    }
};
const promisify = (fn) => function toPromise(...params) {
    if (isFn(params[params.length - 1])) {
        return fn.apply(this, params);
    }
    return new Promise((resolve, reject) => {
        const args = Array.prototype.slice.call(params);
        // add a param to convert callback to promise
        args.push(function pomisifyed(err, res) {
            if (err) {
                return reject(err);
            }
            return resolve(res);
        });
        fn.apply(this, args);
    });
};
export default (cv) => {
    const fns = Object.keys(cv).filter(k => isFn(cv[k])).map(k => cv[k]);
    const asyncFuncs = fns.filter(isAsyncFn);
    const clazzes = fns.filter(fn => fn.prototype && !!Object.keys(fn.prototype).length);
    clazzes.forEach((clazz) => {
        const protoFnKeys = Object.keys(clazz.prototype).filter(k => isAsyncFn(clazz.prototype[k]));
        protoFnKeys.forEach(k => clazz.prototype[k] = promisify(clazz.prototype[k]));
    });
    asyncFuncs.forEach((fn) => {
        const { name } = fn.prototype.constructor;
        cv[name] = promisify(fn);
    });
    return cv;
};
